/**
 * This file is in the public domain.
 * You may do whatever you want with it.
 */
package org.finance.data;

import java.io.*;

public class DailyPlanning implements Serializable {

  private long pureValue;
  private boolean daily;
  private boolean weekly;

  public DailyPlanning(long pureValue, boolean daily, boolean weekly) {
    this.pureValue = pureValue;
    this.daily = daily;
    this.weekly = weekly;
  }

  public long getPureValue() {
    return pureValue;
  }

  public boolean isDaily() {
    return daily;
  }

  public boolean isWeekly() {
    return weekly;
  }

  /**
   * @deprecated Replaces by DailyPlanningFactory.isRemovable
   */
  public boolean isRemovable() {
    return daily && weekly && pureValue == 0;
  }

}