package org.finance.data;

import org.calendar.*;

public class DailyPlanningFactory {

  private static DailyPlanning defaultDailyPlanning = new DailyPlanning(0, true, true);
  private static DailyPlanning defaultWeekendDailyPlanning = new DailyPlanning(0, false, true);

  public static boolean isRemovable(DailyPlanning planning, long date) {
    int dayOfWeek = SimpleDate.getDayOfWeekForLong(date);
    if (SimpleDate.isWeekEnd(dayOfWeek)) {
      return
        defaultWeekendDailyPlanning.getPureValue() == planning.getPureValue() &&
        defaultWeekendDailyPlanning.isDaily() == planning.isDaily() &&
        defaultWeekendDailyPlanning.isWeekly() == planning.isWeekly();
    } else {
      return
        defaultDailyPlanning.getPureValue() == planning.getPureValue() &&
        defaultDailyPlanning.isDaily() == planning.isDaily() &&
        defaultDailyPlanning.isWeekly() == planning.isWeekly();
    }
  }

  public static DailyPlanning getRemovable(int dayOfWeek) {
    if (SimpleDate.isWeekEnd(dayOfWeek)) {
      return defaultWeekendDailyPlanning;
    } else {
      return defaultDailyPlanning;
    }
  }

}