/**
 * This file is in the public domain.
 * You may do whatever you want with it.
 */
package org.finance.data;

public class ValueConverter {

  private static StringBuffer buf = new StringBuffer();

  public static String pureValueToString(long pureValue) {
    buf.setLength(0);
    buf.append(pureValue);
    int min = buf.charAt(0) == '-' ? 1 : 0;
    int minChars = 3 + min;
    while (buf.length() < minChars) {
      buf.insert(min, '0');
    }
    buf.insert(buf.length() - 2, '.');
    for (int i = buf.length() - 6; i > min; i -= 3) {
      buf.insert(i, ',');
    }
    return buf.toString();
  }

  public static String stringToPureValue0(String text) {
    buf.setLength(0);
    if (text == null || text.length() == 0) {
      text = "0";
    }
    int length = text.indexOf('.');
    if (length == -1) {
      length = text.indexOf(',');
    }
    if (length < 0) {
      length = text.length();
    }
    int i = 0;
    for (; i < length; i++) {
      char c = text.charAt(i);
      if (c >= '1' && c <= '9') {
        break;
      }
    }
    for (; i < length; i++) {
      char c = text.charAt(i);
      if (c >= '0' && c <= '9') {
        buf.append(c);
      }
    }
    int count = 0;
    length = text.length();
    for (; i < length && count < 2; i++) {
      char c = text.charAt(i);
      if (c >= '0' && c <= '9') {
        count++;
        buf.append(c);
      }
    }
    if (count == 2 && i < length) {
      char c = text.charAt(i);
      if (c >= '5' && c <= '9') {
        int bufIndex = buf.length() - 1;
        buf.setCharAt(bufIndex, (char)(buf.charAt(bufIndex) + 1));
        while (bufIndex >= 0 && buf.charAt(bufIndex) > '9') {
          buf.setCharAt(bufIndex, '0');
          --bufIndex;
          if (bufIndex == -1) {
            buf.insert(0, '1');
            break;
          } else {
            c = buf.charAt(bufIndex);
            buf.setCharAt(bufIndex, (char)(c + 1));
          }
        }
      }
    }
    for (; count < 2; count++) {
      buf.append('0');
    }

    // return:

    if (buf.length() > 18) {
      return "0";
    }
    if (buf.length() == 0) {
      return "0";
    }
    return buf.toString();
  }

  public static long stringToPureValue(String x) {
    long result = Long.parseLong(stringToPureValue0(x));
    return result;
  }

  public static int stringToInt(String text, int min, int max) {
    buf.setLength(0);
    if (text == null || text.length() == 0) {
      text = "0";
    }
    int length = text.length();
    for (int i = 0; i < length; i++) {
      char c = text.charAt(i);
      if (c >= '0' && c <= '9') {
        buf.append(c);
      }
    }
    try {
      int result = Integer.parseInt(buf.toString());
      if (result < min) return min;
      if (result > max) return max;
      return result;
    } catch (Exception ex) {
      return min;
    }
  }

}