/**
 * This file is in the public domain.
 * You may do whatever you want with it.
 */
package org.finance.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Main extends WindowAdapter {

  private static FinanceLogical fin;

  public void windowClosing(WindowEvent e) {
    System.out.println("size = " + fin.getSize());
    fin.getFinances().takeSnapshot();
    System.exit(0);
  }

  public void windowClosed(WindowEvent e) {
    windowClosing(e);
  }

  public static void main(String[] arg) {
    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        try {
          fin = new FinanceLogical();
          fin.addWindowListener(new Main());
          fin.getFinances().print();
          fin.setSize(new Dimension(757, 475));
          fin.setLocationRelativeTo(null);
          fin.setVisible(true);
        } catch (Throwable error) {
          error.printStackTrace(System.out);
          System.exit(1);
        }
      }
    });
  }

}