/**
 * This file is in the public domain.
 * You may do whatever you want with it.
 */
package org.finance.gui.date;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.util.*;

import org.calendar.*;
import org.finance.data.*;
import org.prevayler.*;
import java.io.*;

public class DayOfWeekPanel extends JComboBox implements ItemListener {

  private SimpleDate date = null;

  private Vector listeners = new Vector();
  private SimpleDate lastEvent = null;
  private boolean working = false;

  public DayOfWeekPanel() {
    this.setModel(new DefaultComboBoxModel(EternalDate.WHOLE_DAYS_BG));
    this.setEditable(false);
    this.setSelectedIndex(0);
    this.addItemListener(this);
  }

  public void setDate(SimpleDate date) {
    working = true;
    try {
      this.date = date = date.getDayOfWeekAsDate();
      if (lastEvent == null) {
        lastEvent = date;
      }
      this.setSelectedIndex(date.getDayOfWeek());
    } finally {
      working = false;
    }
  }

  public SimpleDate getDate() {
    return date.findDayOfWeekInMonth(super.getSelectedIndex());
  }

  public void itemStateChanged(ItemEvent e) {
    if (working) return;
    working = true;
    try {
      fireDateChange();
    } finally {
      working = false;
    }
  }

  public void addDateChangeListener(DateChangeListener listener) {
    if (this.listeners.indexOf(listener) < 0) {
      this.listeners.addElement(listener);
    }
  }

  private void fireDateChange() {
    SimpleDate date = getDate();
    if (date.equals(lastEvent)) {
      return;
    }
    lastEvent = date;
    int size = this.listeners.size();
    for (int i = 0; i < size; i++) {
      DateChangeListener listener = (DateChangeListener)this.listeners.elementAt(i);
      listener.dateChanged(this);
    }
  }

}
