/**
 * This file is in the public domain.
 * You may do whatever you want with it.
 */
package org.prevaylerwrapper;

import org.prevayler.*;
import java.io.Serializable;
import java.lang.reflect.*;

public class CommandProxyCommand implements Command {

  private String method;
  private Object[] args;
  private Class[] types;

  public CommandProxyCommand(String method, Object[] args, Class[] types) {
    this.method = method;
    this.args = args;
    this.types = types;
  }

  public Serializable execute(PrevalentSystem pf) throws Exception {
    System.out.println("CommandProxyCommand.execute : " + method);
    try {
      Data data = (Data)pf;
      CommandSystem system = data.getSystem();
      Method m = system.getClass().getMethod(method, types);
      m.invoke(system, args);
    } catch (Throwable error) {
      error.printStackTrace();
    }
    return null;
  }

}